package com.jackyjjc.bookevaluator.controller;

import com.jackyjjc.bookevaluator.gui.WordDialog;

import java.awt.event.KeyEvent;
import java.util.Iterator;

/**
 * @author Junjie CHEN(jacky.jjchen@gmail.com)
 */
public class LearnerKeyListener implements WordDialogListener {

    private WordDialog wordDialog;

    private Iterator<String> unknownWordList;

    public LearnerKeyListener(Iterator<String> unknownWordList) {
        this.unknownWordList = unknownWordList;
    }

    @Override
    public void keyReleased(KeyEvent e) {

        /*[esc] will dispose the dialog*/
        if(e.getKeyCode() == KeyEvent.VK_ESCAPE) {
            onClose();
            return;
        }

        //only [Space]will have effects
        if(e.getKeyCode() != KeyEvent.VK_SPACE) {
            return;
        }

        //display the next word
        if(unknownWordList.hasNext()) {
            this.wordDialog.setWord(unknownWordList.next());
        } else {
            this.onClose();
            this.wordDialog.dispose();
        }
    }

    @Override
    public void setWordDialog(WordDialog wordDialog) {
        this.wordDialog = wordDialog;
        this.wordDialog.setHelpMessage("press [Space] to display the next word.");
    }

    @Override
    public void keyTyped(KeyEvent e) {
    }

    @Override
    public void keyPressed(KeyEvent e) {
    }


    @Override
    public void onClose() {
    }
}
