package com.jackyjjc.bookevaluator.controller;

import com.jackyjjc.bookevaluator.gui.WordDialog;
import com.jackyjjc.bookevaluator.model.Dictionary;
import com.jackyjjc.bookevaluator.model.WordList;

import java.awt.event.KeyEvent;
import java.util.Iterator;

/**
 * @author Junjie CHEN(jacky.jjchen@gmail.com)
 */
public abstract class WordDialogModifyListener implements WordDialogListener {

    protected WordDialog wordDialog;
    protected Dictionary dict;
    protected WordList wordList;
    protected Iterator<String> wordsToDisplay;

    public WordDialogModifyListener(Dictionary dict, WordList wordList) {
        this.dict = dict;
        this.wordList = wordList;
        this.wordsToDisplay = wordList.iterator();
    }

    public abstract void setWordDialog(WordDialog dialog);

    public void onClose() {
        System.out.println("on close");
        this.dict.save();
        this.wordList.save();
        this.wordDialog.dispose();
    }

    @Override
    public void keyTyped(KeyEvent e) {
    }

    @Override
    public void keyPressed(KeyEvent e) {
    }
}
