package com.jackyjjc.bookevaluator.controller;

import com.jackyjjc.bookevaluator.gui.WordDialog;
import com.jackyjjc.bookevaluator.model.Dictionary;
import com.jackyjjc.bookevaluator.model.WordList;

import java.awt.event.KeyEvent;

/**
 * @author Junjie CHEN(jacky.jjchen@gmail.com)
 */
public class WordlistUpdateListener extends WordDialogModifyListener {

    public WordlistUpdateListener(Dictionary dict, WordList wordList) {
        super(dict, wordList);
    }

    @Override
    public void setWordDialog(WordDialog dialog) {
        this.wordDialog = dialog;
        this.wordDialog.setHelpMessage("[S] to skip",
                                       "[D] to delete");
    }

    @Override
    public void keyReleased(KeyEvent e) {

        /*[esc] will dispose the dialog*/
        if(e.getKeyCode() == KeyEvent.VK_ESCAPE) {
            onClose();
            return;
        }

        //only S or D will have effects
        if(e.getKeyCode() != KeyEvent.VK_S && e.getKeyCode() != KeyEvent.VK_D) {
            return;
        }

        //if [A] is pressed then the word is added into dictionary
        if(e.getKeyCode() == KeyEvent.VK_D) {
            wordList.remove(wordDialog.getWord());
            dict.add(wordDialog.getWord());
        }

        //display the next word
        if(wordsToDisplay.hasNext()) {
            wordDialog.setWord(wordsToDisplay.next());
        } else {
            this.onClose();
            this.wordDialog.dispose();
        }
    }
}
