package com.jackyjjc.bookevaluator.io;

import java.io.*;

/**
 * @author Junjie CHEN(jacky.jjchen@gmail.com)
 */
public class TXTReader implements BookReader {

    private BufferedReader reader;
    private String[] words;
    private int i;

    @Override
    public void open(File file) throws IOException {
        this.reader = new BufferedReader(new FileReader(file));
    }

    @Override
    public String getNextWord() throws IOException {

        String line;

        while (words == null || words.length == i) {
            line = reader.readLine();
            if(line == null) {
                return null;
            }
            line.trim();
            //words = line.split("[^a-zA-Z']+");
            words = line.split("\\W+");
            i = 0;
        }

        return words[i++].toLowerCase();
    }

    @Override
    public void close() throws IOException {
        reader.close();
    }
}
