package com.jackyjjc.bookevaluator.main;

/**
 * @author Junjie CHEN(jacky.jjchen@gmail.com)
 */
public class Runner {


    public static void main(String[] args) {

        boolean validArgs = false;

        if(args.length > 0) {

            String flag = args[0];

            if(flag.equals("-e")) {

                BookEvaluator bookEvaluator = new BookEvaluator();
                if(bookEvaluator.setArguments(args)) {
                    bookEvaluator.run();
                    validArgs = true;
                }

            } else if(flag.equals("-d")) {

                DictionaryUpdater updater = new DictionaryUpdater();
                if(updater.setArguments(args)) {
                    updater.run();
                    validArgs = true;
                }

            } else if(flag.equals("-w") && args.length == 1) {

                ListUpdater updater = new ListUpdater();
                updater.run();
                validArgs = true;

            } else if(flag.equals("-l") && args.length == 1) {
                Learner learner = new Learner();
                learner.run();
                validArgs = true;
            }
        }

        if(!validArgs) {
            printHelp();
            return;
        }
    }

    private static void printHelp() {
        System.out.println("Usage: [-e|-d|-w|-l] (options) (path)");
        System.out.println("-e path: evalute a book and show the result of the analysis.");
        System.out.println("-d path: interactively input words into dictionary.");
        System.out.println("   -a path: input all the words into dictionary.");
        System.out.println("-w: interactively update the unknown words list.");
        System.out.println("-l: unknown words learning mode.");
    }
}
