package com.jackyjjc.bookevaluator.model;

import com.jackyjjc.bookevaluator.io.FileIO;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

/**
 * @author Junjie CHEN(jacky.jjchen@gmail.com)
 */
public class Dictionary {

    private static final String filename = "dictionary.be";

    private static Dictionary dict = null;

    /*words that is already known to the user*/
    private Set<String> knownWords;

    private List<String> wordsToAdd;

    private Dictionary(Set<String> knownWords) {
        this.knownWords = knownWords;
        this.wordsToAdd = new ArrayList<String>();
    }

    public boolean contains(String word) {
        return knownWords.contains(word) || wordsToAdd.contains(word);
    }

    public void add(String word) {
        if(word.length() != 0 && !contains(word)) {
            this.wordsToAdd.add(word);
        }
    }

    public List<String> getWordsToAdd() {
        return wordsToAdd;
    }

    public void save() {
        FileIO.appendToFile(filename, dict.getWordsToAdd().iterator());
    }

    public static Dictionary getDictionary() {

        if(dict == null) {
            dict = new Dictionary(FileIO.readWordsFromInternalFile(filename));
        }

        return dict;
    }
}
