package com.jackyjjc.bookevaluator.model;

import com.jackyjjc.bookevaluator.io.FileIO;

import java.util.Iterator;
import java.util.Set;

/**
 * @author Junjie CHEN(jacky.jjchen@gmail.com)
 */
public class WordList implements Iterable<String> {

    private static final String fileName = "wordlist.be";

    private static WordList list = null;

    private Set<String> wordList;

    private WordList(Set<String> wordList) {
        this.wordList = wordList;
    }

    public static WordList getWordList() {
        if(list == null) {
            list = new WordList(FileIO.readWordsFromInternalFile(fileName));
        }

        return list;
    }

    public boolean contains(String word) {
        return this.wordList.contains(word);
    }

    public void add(String word) {
        if(!contains(word)) {
            this.wordList.add(word);
        }
    }

    public void remove(String word) {
        this.wordList.remove(word);
    }

    public void save() {
        FileIO.writeToFile(fileName, wordList.iterator());
    }

    @Override
    public Iterator<String> iterator() {
        return wordList.iterator();
    }
}
